/****************************************************************************
 *   Copyright (C) 2004 by Arboretum Systems, Inc.                          *
 *   Technical administrator: Alain Mazy, hav@mazy.be                       *
 *   Lead program designer: Georges Jaroslaw, gjaro@arboretum.com           *
 *                                                                          *
 *   HyperEngine-AV is a video, audio and text editor that can be used to   *
 *   record, import, edit, process and arrange together video, sound and    *
 *   text. These are all achieved in the program's free-form document       *
 *   window, with no limitations to the number of tracks.                   *
 *   The purpose of this program is to provide to users at all levels of    *
 *   expertise a readily accessible tool enabling them to create movies,    *
 *   slide shows or presentations.                                          *
 *                                                                          *
 *   HyperEngine-AV itself is free software. However, plug-ins that can be  *
 *   used as add-ons to HyperEngine-AV may or may not be free software, at  *
 *   the discretion of each plug-in developer and as specified by these     *
 *   plug-ins' respective licenses.                                         *
 *   You can redistribute HyperEngine-AV itself and/or modify it under the  *
 *   terms of the GNU General Public License as published by the Free       *
 *   Software Foundation; either version 2 of the License, or (at your      *
 *   option) any later version.                                             *
 *                                                                          *
 *   HyperEngine-AV is distributed in the hope that it will be useful, but  *
 *   WITHOUT ANY WARRANTY; without even the implied warranty of             *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the          *
 *   GNU General Public License for all applicable details.                 *
 *                                                                          *
 *   You should have received a copy of the GNU General Public License      *
 *   along with this program; if not, write to:                             *
 *   Free Software Foundation, Inc.,                                        *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.              *
 ****************************************************************************/

#define VARPIPluginSet_h

#ifndef VARPIPluginSet_h
#include "VARPIPluginSet.h"
#endif //VARPIPluginSet_h

#ifndef ZzTypes_h
#include "ZzTypes.h"
#endif //ZzTypes_h


// for now plugin protection is implemented in VARPIPluginClass
// eventually it should wind up here: one licence per plugin set


class VARPIPluginClass;

class VARPIPluginSet
{
public :
	virtual SInt32				GetNbPluginClasses() = 0;
	virtual VARPIPluginClass*	GetPluginClass(SInt32 i) = 0;
	virtual ~VARPIPluginSet() {};
	
/*
	virtual void			_reserved03();
	virtual void			_reserved04();
	virtual void			_reserved05();
	virtual void			_reserved06();
	virtual void			_reserved07();
	virtual void			_reserved08();
	virtual void			_reserved09();
	virtual void			_reserved10();
	virtual void			_reserved11();
	virtual void			_reserved12();
	virtual void			_reserved13();
	virtual void			_reserved14();
	virtual void			_reserved15();
	virtual void			_reserved16();
	virtual void			_reserved17();
	virtual void			_reserved18();
	virtual void			_reserved19();
	virtual void			_reserved20();
	virtual void			_reserved21();
	virtual void			_reserved22();
	virtual void			_reserved23();
	virtual void			_reserved24();
	virtual void			_reserved25();
	virtual void			_reserved26();
	virtual void			_reserved27();
	virtual void			_reserved28();
	virtual void			_reserved29();
	virtual void			_reserved30();
	virtual void			_reserved31();
	virtual void			_reserved32();
*/
};
