/****************************************************************************
 *   Copyright (C) 2004 by Arboretum Systems, Inc.                          *
 *   Technical administrator: Alain Mazy, hav@mazy.be                       *
 *   Lead program designer: Georges Jaroslaw, gjaro@arboretum.com           *
 *                                                                          *
 *   HyperEngine-AV is a video, audio and text editor that can be used to   *
 *   record, import, edit, process and arrange together video, sound and    *
 *   text. These are all achieved in the program's free-form document       *
 *   window, with no limitations to the number of tracks.                   *
 *   The purpose of this program is to provide to users at all levels of    *
 *   expertise a readily accessible tool enabling them to create movies,    *
 *   slide shows or presentations.                                          *
 *                                                                          *
 *   HyperEngine-AV itself is free software. However, plug-ins that can be  *
 *   used as add-ons to HyperEngine-AV may or may not be free software, at  *
 *   the discretion of each plug-in developer and as specified by these     *
 *   plug-ins' respective licenses.                                         *
 *   You can redistribute HyperEngine-AV itself and/or modify it under the  *
 *   terms of the GNU General Public License as published by the Free       *
 *   Software Foundation; either version 2 of the License, or (at your      *
 *   option) any later version.                                             *
 *                                                                          *
 *   HyperEngine-AV is distributed in the hope that it will be useful, but  *
 *   WITHOUT ANY WARRANTY; without even the implied warranty of             *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the          *
 *   GNU General Public License for all applicable details.                 *
 *                                                                          *
 *   You should have received a copy of the GNU General Public License      *
 *   along with this program; if not, write to:                             *
 *   Free Software Foundation, Inc.,                                        *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.              *
 ****************************************************************************/

/*
	generic errors
*/
ARME_ERROR_DEF(kArmeOK)
ARME_ERROR_DEF(kArmeErrUnknown)
ARME_ERROR_DEF(kArmeErrResources)
ARME_ERROR_DEF(kArmeErrNYI)


ARME_ERROR_DEF(kCoreAudioError)
ARME_ERROR_DEF(kCoreAudioNoInputDeviceFound)
ARME_ERROR_DEF(kCoreAudioDeviceNotUsingLinearPCMError)
ARME_ERROR_DEF(kArmeQuickTimeError)
ARME_ERROR_DEF(kArmeErrEmptyQTAudioTrack)
ARME_ERROR_DEF(kArmeCannotCreateFSSpecFromPath)
ARME_ERROR_DEF(kArmeQuickTimeErrorNoMedia)
ARME_ERROR_DEF(kArmeErrNoRecordingDevice)
ARME_ERROR_DEF(kArmeErrNoPCMRecordingDevice)
ARME_ERROR_DEF(kArmeErrNoPCMFloatingPointRecordingDevice)

/*
	Media handler errors
*/
ARME_ERROR_DEF(kArmeErrMediaHandlerNotAllStreamsImported)
ARME_ERROR_DEF(kArmeErrMediaHandlerNoStreamImported)
ARME_ERROR_DEF(kArmeErrFormatUnsupported)
ARME_ERROR_DEF(kArmeErrNoSuitableMediaHandlerFound)
ARME_ERROR_DEF(kArmeErrMediaHandlerCannotImport)

/*
	QT sample reader errors
*/

ARME_ERROR_DEF(kArmeErrNilSoundTrack)
ARME_ERROR_DEF(kArmeErrPutMovieIntoTypedHandle)
ARME_ERROR_DEF(kArmeErrGetSoundHeaderOffset)
ARME_ERROR_DEF(kArmeErrUnknownSoundHeaderType)
ARME_ERROR_DEF(kArmeErrWrongSoundHeaderParsing)
ARME_ERROR_DEF(kArmeErrQTSampleReaderStarvation) // means 0 frames were read even though the end of the file hasn't been reached yet.
ARME_ERROR_DEF(kArmeErrCantSupportMultichannelMovies)
ARME_ERROR_DEF(kArmeErrCantStartSoundConverter)

/*
	audio clip error
*/
ARME_ERROR_DEF(kArmeErrTAudioClipCannotOpenAudioFile)
ARME_ERROR_DEF(kArmeAudioProcCancelled)
ARME_ERROR_DEF(kArmeAudioProcFailed)
ARME_ERROR_DEF(kArmeErrCannotOpenFileForWriting)
ARME_ERROR_DEF(kArmeErrCannotOpenFileForReading)
ARME_ERROR_DEF(kArmeErrErrorWritingInFile)
ARME_ERROR_DEF(kArmeErrErrorReadingInFile)
ARME_ERROR_DEF(kArmeErrErrorSeekingInFile)


/*
	video clip error
*/
ARME_ERROR_DEF(kArmeErrTVideoClipCannotOpenVideoFile)
ARME_ERROR_DEF(kArmeCantRenderMovie)	

/*
	PCM audio file reader error
*/

// data is the OSStatus of the error
ARME_ERROR_DEF(kArmeAudioFileCannotOpen)

// cannot retrieve info from the file
ARME_ERROR_DEF(kArmeAudioFileCannotGetInfo)

// not suitable for realtime
ARME_ERROR_DEF(kArmeAudioFileNotSuitableForRealTime)

// greater than LONG_LONG_MAX
ARME_ERROR_DEF(kArmeAudioFileTooBigAFile)

// audio conversion error
ARME_ERROR_DEF(kArmeAudioFileAudioConverterError)

ARME_ERROR_DEF(kArmeErrorClosingSFPAudioFile)

ARME_ERROR_DEF(kArmeErrorCreatingSFPAudioFileConverter)

ARME_ERROR_DEF(kArmeErrorReadingUsingAudioFileAPI)

/*
	export error
*/

ARME_ERROR_DEF(kArmeErrorAudioExportInAddMediaSample)

/*
	max error index
*/
ARME_ERROR_DEF(	kArmeErrNbOfErrors)




