/****************************************************************************
 *   Copyright (C) 2004 by Arboretum Systems, Inc.                          *
 *   Technical administrator: Alain Mazy, hav@mazy.be                       *
 *   Lead program designer: Georges Jaroslaw, gjaro@arboretum.com           *
 *                                                                          *
 *   HyperEngine-AV is a video, audio and text editor that can be used to   *
 *   record, import, edit, process and arrange together video, sound and    *
 *   text. These are all achieved in the program's free-form document       *
 *   window, with no limitations to the number of tracks.                   *
 *   The purpose of this program is to provide to users at all levels of    *
 *   expertise a readily accessible tool enabling them to create movies,    *
 *   slide shows or presentations.                                          *
 *                                                                          *
 *   HyperEngine-AV itself is free software. However, plug-ins that can be  *
 *   used as add-ons to HyperEngine-AV may or may not be free software, at  *
 *   the discretion of each plug-in developer and as specified by these     *
 *   plug-ins' respective licenses.                                         *
 *   You can redistribute HyperEngine-AV itself and/or modify it under the  *
 *   terms of the GNU General Public License as published by the Free       *
 *   Software Foundation; either version 2 of the License, or (at your      *
 *   option) any later version.                                             *
 *                                                                          *
 *   HyperEngine-AV is distributed in the hope that it will be useful, but  *
 *   WITHOUT ANY WARRANTY; without even the implied warranty of             *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the          *
 *   GNU General Public License for all applicable details.                 *
 *                                                                          *
 *   You should have received a copy of the GNU General Public License      *
 *   along with this program; if not, write to:                             *
 *   Free Software Foundation, Inc.,                                        *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.              *
 ****************************************************************************/

#ifndef BuiltinEffectsSet_h
#include "BuiltinEffectsSet.h"
#endif //BuiltinEffectsSet_h



#include "BandPass.h"
#include "Vibrato.h"
#include "AutoPan.h"

BuiltinEffectsSet::BuiltinEffectsSet()
{
	int i=0;
	
		// free plugin
		fPluginClasses[i] = new BandPassPluginClass();
		fPluginClasses[i]->SetPluginIsDemo(0);
		i++;

		// free plugin
		fPluginClasses[i] = new VibratoPluginClass();
		fPluginClasses[i]->SetPluginIsDemo(0);
		i++;

		// free plugin
		fPluginClasses[i] = new AutoPanPluginClass();
		fPluginClasses[i]->SetPluginIsDemo(0);
		i++;

	fNbPluginClasses = i;
}

SInt32 BuiltinEffectsSet::GetNbPluginClasses()
{
	return fNbPluginClasses;
}

VARPIPluginClass* BuiltinEffectsSet::GetPluginClass(SInt32 i)
{
	if(i >= fNbPluginClasses)
    {
        vertl(hyperPrismTom,0,"BuiltinEffectsSet::GetPluginClass index >= fNbPluginClasses ");
		return NULL;
    }
	return fPluginClasses[i];
}
