/****************************************************************************
 *   Copyright (C) 2004 by Arboretum Systems, Inc.                          *
 *   Technical administrator: Alain Mazy, hav@mazy.be                       *
 *   Lead program designer: Georges Jaroslaw, gjaro@arboretum.com           *
 *                                                                          *
 *   HyperEngine-AV is a video, audio and text editor that can be used to   *
 *   record, import, edit, process and arrange together video, sound and    *
 *   text. These are all achieved in the program's free-form document       *
 *   window, with no limitations to the number of tracks.                   *
 *   The purpose of this program is to provide to users at all levels of    *
 *   expertise a readily accessible tool enabling them to create movies,    *
 *   slide shows or presentations.                                          *
 *                                                                          *
 *   HyperEngine-AV itself is free software. However, plug-ins that can be  *
 *   used as add-ons to HyperEngine-AV may or may not be free software, at  *
 *   the discretion of each plug-in developer and as specified by these     *
 *   plug-ins' respective licenses.                                         *
 *   You can redistribute HyperEngine-AV itself and/or modify it under the  *
 *   terms of the GNU General Public License as published by the Free       *
 *   Software Foundation; either version 2 of the License, or (at your      *
 *   option) any later version.                                             *
 *                                                                          *
 *   HyperEngine-AV is distributed in the hope that it will be useful, but  *
 *   WITHOUT ANY WARRANTY; without even the implied warranty of             *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the          *
 *   GNU General Public License for all applicable details.                 *
 *                                                                          *
 *   You should have received a copy of the GNU General Public License      *
 *   along with this program; if not, write to:                             *
 *   Free Software Foundation, Inc.,                                        *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.              *
 ****************************************************************************/

#ifndef TArmeVideoFileHandler_h
#include "TArmeVideoFileHandler.h"
#endif //TArmeVideoFileHandler_h

#ifndef TArmeMediaEngine_h
#include "TArmeMediaEngine.h"
#endif //TArmeMediaEngine_h

#ifndef TArmeDoc_h
#include "TArmeDoc.h"
#endif //TArmeDoc_h

#ifndef TVideoClip_h
#include "TVideoClip.h"
#endif //TVideoClip_h

#ifndef ZzHelpers_h
#include "ZzHelpers.h"
#endif //ZzHelpers_h

#ifndef MovieHelper_h
#include "MovieHelper.h"
#endif //MovieHelper_h

#ifndef TArmeMasterMovie_h
#include "TArmeMasterMovie.h"
#endif //TArmeMasterMovie_h

/*
TArmeWSObj* TArmeVideoFileHandler::CreateWSObjFromFile( 
    TArmeDoc* 				pDoc, 
    const char*				path, 
    const TArmeWSObjPos&	pos,
	ZzSplitTask**			splitTask,
	ArmeErr*				err)
{
	ZzAssert(0); //still used ?

//	TVideoClip* pClip = new TVideoClip(path, pDoc, bopTask, err, pos);
//	if(err->type!=kArmeOK)
		return NULL;
	
//	return pClip;
}
*/
char* TArmeVideoFileHandler::fsExtensions[] =
{
	"mov",
	"dv",
	"Mov",
	"Dv",
	"MOV",
	"DV"
	// don't forget to modify the GetSupportedExtensionsCount() function as you add new extensions here
};

int32 TArmeVideoFileHandler::GetSupportedExtensionsCount()
{
	return 6;
}

char* TArmeVideoFileHandler::GetSupportedExtension(int32 i)
{
	return fsExtensions[i];
}






