/****************************************************************************
 *   Copyright (C) 2004 by Arboretum Systems, Inc.                          *
 *   Technical administrator: Alain Mazy, hav@mazy.be                       *
 *   Lead program designer: Georges Jaroslaw, gjaro@arboretum.com           *
 *                                                                          *
 *   HyperEngine-AV is a video, audio and text editor that can be used to   *
 *   record, import, edit, process and arrange together video, sound and    *
 *   text. These are all achieved in the program's free-form document       *
 *   window, with no limitations to the number of tracks.                   *
 *   The purpose of this program is to provide to users at all levels of    *
 *   expertise a readily accessible tool enabling them to create movies,    *
 *   slide shows or presentations.                                          *
 *                                                                          *
 *   HyperEngine-AV itself is free software. However, plug-ins that can be  *
 *   used as add-ons to HyperEngine-AV may or may not be free software, at  *
 *   the discretion of each plug-in developer and as specified by these     *
 *   plug-ins' respective licenses.                                         *
 *   You can redistribute HyperEngine-AV itself and/or modify it under the  *
 *   terms of the GNU General Public License as published by the Free       *
 *   Software Foundation; either version 2 of the License, or (at your      *
 *   option) any later version.                                             *
 *                                                                          *
 *   HyperEngine-AV is distributed in the hope that it will be useful, but  *
 *   WITHOUT ANY WARRANTY; without even the implied warranty of             *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the          *
 *   GNU General Public License for all applicable details.                 *
 *                                                                          *
 *   You should have received a copy of the GNU General Public License      *
 *   along with this program; if not, write to:                             *
 *   Free Software Foundation, Inc.,                                        *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.              *
 ****************************************************************************/

#define MEAudioMonitoring_h

#ifndef MEAudioMonitoring_h
#include "MEAudioMonitoring.h"
#endif //MEAudioMonitoring_h

#ifndef ZzLocker_h
#include "ZzLocker.h"
#endif //ZzLocker_h

class ZzRingBuffer;

class MEAudioMonitoring
{
public :
			MEAudioMonitoring(UInt32 log2RingBufferNbFrames,UInt32 nbChannels);
	void 	MixCurrentDataIntoBuffer(float* raoDest, SInt32 raoNbChannels, float* tmpStereoBuf,SInt32 nbFrames);
	void 	WriteFrames(float* frames, SInt32 nbFrames);
	void	SetSecondaryMute(bool muted);
	void	SetMute(bool muted);

	bool	IsSecondaryMuted() const;
	bool	IsMuted() const;

	
public :
	ZzLocker								fMonitoringRingBufferPosLocker;
	ZzRingBuffer*							fMonitoringRingBuffer;
	
	/*! @var fSecondaryMuteGain this is a 2nd mute used when playing back takes in the audio capture
		it allows to mute while at the same time keeping the main mute value correct */
	float									fSecondaryMuteGain;
	float									fMainMuteGain;
};
