/****************************************************************************
 *   Copyright (C) 2004 by Arboretum Systems, Inc.                          *
 *   Technical administrator: Alain Mazy, hav@mazy.be                       *
 *   Lead program designer: Georges Jaroslaw, gjaro@arboretum.com           *
 *                                                                          *
 *   HyperEngine-AV is a video, audio and text editor that can be used to   *
 *   record, import, edit, process and arrange together video, sound and    *
 *   text. These are all achieved in the program's free-form document       *
 *   window, with no limitations to the number of tracks.                   *
 *   The purpose of this program is to provide to users at all levels of    *
 *   expertise a readily accessible tool enabling them to create movies,    *
 *   slide shows or presentations.                                          *
 *                                                                          *
 *   HyperEngine-AV itself is free software. However, plug-ins that can be  *
 *   used as add-ons to HyperEngine-AV may or may not be free software, at  *
 *   the discretion of each plug-in developer and as specified by these     *
 *   plug-ins' respective licenses.                                         *
 *   You can redistribute HyperEngine-AV itself and/or modify it under the  *
 *   terms of the GNU General Public License as published by the Free       *
 *   Software Foundation; either version 2 of the License, or (at your      *
 *   option) any later version.                                             *
 *                                                                          *
 *   HyperEngine-AV is distributed in the hope that it will be useful, but  *
 *   WITHOUT ANY WARRANTY; without even the implied warranty of             *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the          *
 *   GNU General Public License for all applicable details.                 *
 *                                                                          *
 *   You should have received a copy of the GNU General Public License      *
 *   along with this program; if not, write to:                             *
 *   Free Software Foundation, Inc.,                                        *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.              *
 ****************************************************************************/

#define OfflineAudioProcessorFadeOut_h

#ifndef OfflineAudioProcessorFadeOut_h
#include "OfflineAudioProcessorFadeOut.h"
#endif //OfflineAudioProcessorFadeOut_h

#ifndef OfflineAudioProcessing_h
#include "OfflineAudioProcessing.h"
#endif //OfflineAudioProcessing_h

class OfflineAudioProcessorFadeOutParams : public OfflineAudioProcessorParams
{
public:
	OfflineAudioProcessorFadeOutParams();
    float getAttenuationDBValue() {return fAttenuationDBValue;}
    void  setAttenuationDBValue(float val) {fAttenuationDBValue = val;}
    int	  getFadeType() {return fFadeType;}
    void  setFadeType(int t){fFadeType = t;}
 
private:
    float fAttenuationDBValue;
    int	  fFadeType; // 0 = linear and 1 = log.

};

class OfflineAudioProcessorFadeOut : public OfflineAudioProcessorBase<OfflineAudioProcessorFadeOut>
{
public :
	virtual OfflineAudioProcessorParams*	CreateDefaultParams();

	virtual	bool							DisplayAudioProcessorConfiguration(
												OfflineAudioProcessorParams* offlineParams);
                                                
	virtual ArmeErr							PerformAudioProcessing(
												OfflineAudioProcessorParams* offlineParams);
	virtual bool							IsLengthy(OfflineAudioProcessorParams* offlineParams);
	virtual ~OfflineAudioProcessorFadeOut() {};
    
private:

    ArmeErr 								PerformFadeOutLinear(
                                                OfflineAudioProcessorParams* offlineParams);
    ArmeErr									PerformFadeOutLogarithmic(
                                                OfflineAudioProcessorParams* offlineParams);
};
