/****************************************************************************
 *   Copyright (C) 2004 by Arboretum Systems, Inc.                          *
 *   Technical administrator: Alain Mazy, hav@mazy.be                       *
 *   Lead program designer: Georges Jaroslaw, gjaro@arboretum.com           *
 *                                                                          *
 *   HyperEngine-AV is a video, audio and text editor that can be used to   *
 *   record, import, edit, process and arrange together video, sound and    *
 *   text. These are all achieved in the program's free-form document       *
 *   window, with no limitations to the number of tracks.                   *
 *   The purpose of this program is to provide to users at all levels of    *
 *   expertise a readily accessible tool enabling them to create movies,    *
 *   slide shows or presentations.                                          *
 *                                                                          *
 *   HyperEngine-AV itself is free software. However, plug-ins that can be  *
 *   used as add-ons to HyperEngine-AV may or may not be free software, at  *
 *   the discretion of each plug-in developer and as specified by these     *
 *   plug-ins' respective licenses.                                         *
 *   You can redistribute HyperEngine-AV itself and/or modify it under the  *
 *   terms of the GNU General Public License as published by the Free       *
 *   Software Foundation; either version 2 of the License, or (at your      *
 *   option) any later version.                                             *
 *                                                                          *
 *   HyperEngine-AV is distributed in the hope that it will be useful, but  *
 *   WITHOUT ANY WARRANTY; without even the implied warranty of             *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the          *
 *   GNU General Public License for all applicable details.                 *
 *                                                                          *
 *   You should have received a copy of the GNU General Public License      *
 *   along with this program; if not, write to:                             *
 *   Free Software Foundation, Inc.,                                        *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.              *
 ****************************************************************************/

#define OfflineAudioProcessorNormalize_h

#ifndef OfflineAudioProcessorNormalize_h
#include "OfflineAudioProcessorNormalize.h"
#endif //OfflineAudioProcessorNormalize_h

#ifndef OfflineAudioProcessing_h
#include "OfflineAudioProcessing.h"
#endif //OfflineAudioProcessing_h

class OfflineAudioProcessorNormalizeParams : public OfflineAudioProcessorParams
{
public :
	void	SetAcrossAllClips(bool flag) { bAcrossAllClips = flag; }
	bool	IsAcrossAllClips() { return bAcrossAllClips; }
    void	SetDBVal(float val) { fDBVal = val; }
    float	GetDBVal() { return fDBVal; }
private :
	bool	bAcrossAllClips;
    float	fDBVal;
};

class OfflineAudioProcessorNormalize : public OfflineAudioProcessorBase<OfflineAudioProcessorNormalize>
{
public :
	virtual OfflineAudioProcessorParams*	CreateDefaultParams();

	virtual	bool							DisplayAudioProcessorConfiguration(
												OfflineAudioProcessorParams* offlineParams);
	virtual ArmeErr							PerformAudioProcessing(
												OfflineAudioProcessorParams* offlineParams);
	virtual bool							IsLengthy(OfflineAudioProcessorParams* offlineParams);
	virtual ~OfflineAudioProcessorNormalize() {};
private :	
	void 	Multiply(
				ZzProgressTracker*	progressTracker, 
				OfflineAudioWriter*	writer, 
				OfflineAudioReader*	reader, 
				float 				factor);
};
