/****************************************************************************
 *   Copyright (C) 2004 by Arboretum Systems, Inc.                          *
 *   Technical administrator: Alain Mazy, hav@mazy.be                       *
 *   Lead program designer: Georges Jaroslaw, gjaro@arboretum.com           *
 *                                                                          *
 *   HyperEngine-AV is a video, audio and text editor that can be used to   *
 *   record, import, edit, process and arrange together video, sound and    *
 *   text. These are all achieved in the program's free-form document       *
 *   window, with no limitations to the number of tracks.                   *
 *   The purpose of this program is to provide to users at all levels of    *
 *   expertise a readily accessible tool enabling them to create movies,    *
 *   slide shows or presentations.                                          *
 *                                                                          *
 *   HyperEngine-AV itself is free software. However, plug-ins that can be  *
 *   used as add-ons to HyperEngine-AV may or may not be free software, at  *
 *   the discretion of each plug-in developer and as specified by these     *
 *   plug-ins' respective licenses.                                         *
 *   You can redistribute HyperEngine-AV itself and/or modify it under the  *
 *   terms of the GNU General Public License as published by the Free       *
 *   Software Foundation; either version 2 of the License, or (at your      *
 *   option) any later version.                                             *
 *                                                                          *
 *   HyperEngine-AV is distributed in the hope that it will be useful, but  *
 *   WITHOUT ANY WARRANTY; without even the implied warranty of             *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the          *
 *   GNU General Public License for all applicable details.                 *
 *                                                                          *
 *   You should have received a copy of the GNU General Public License      *
 *   along with this program; if not, write to:                             *
 *   Free Software Foundation, Inc.,                                        *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.              *
 ****************************************************************************/
 
#ifdef DSP_Globals_h
#error ("DSP_Globals.h included twice. SHIT !!!!!!!!!!!!!!!!!!!!!!!")
#endif //DSP_Globals_h

#define DSP_Globals_h

#ifndef DSP_Globals_h
#include "DSP_Globals.h"
#endif //DSP_Globals_h

#ifdef WIN32
		#include <stdlib.h>
		#include <float.h>
		#include <math.h>

	typedef __int64 Int64;
	typedef __int32 Int32;
	typedef __int16 Int16;
	typedef __int8 Int8;
	const Int32 nil=0;
#else
//	#include <fp.h>
	// AML 9/30/98
	#include "PP_Types.h"
#endif

#ifdef _MSC_VER
#pragma warning( disable: 4244 ) // warning C4244: '=' : conversion from 'double' to 'float', possible loss of data (there's an awful lots of those in there)
#endif //_MSC_VER

#ifndef ZzTypes_h
#include "../../Zz/ZzTypes.h"
#endif //ZzTypes_h

#include "DSP_Float2Int.h"

//Set this to double or float depending upon the required amount of precision.
//typedef float GFLOAT;
const double kPi=3.1415926535897932384626433832795;
const double kTwoPi=2.0*3.1415926535897932384626433832795;
const double kHalfPi=0.5*3.1415926535897932384626433832795;
const double kQuarterPi=0.25*3.1415926535897932384626433832795;
const double kInvPi=1.0/3.1415926535897932384626433832795;
const double kInvTwoPi=1.0/(2.0*3.1415926535897932384626433832795);
const double kRootTwo=1.414213562373;
const double kInvRootTwo=0.7071067811865;

// Make sure the plug-in initializes the SampleRate etc. and checks that it is in the proper range.



extern float SampleRateFloat;	// Current sample format
extern Int32 SampleRateInt;	// Current sample format
extern Int32 BytesPerSample;	// Current sample format
extern Int32 Channels;			// Current sample format
extern float InvSampleRate;

const float kMaxSampleRate=192000.0f;	// Limit sample rate to 192.0 KHz
const float kMinSampleRate=1000.0f;
const float kInvMaxSampleRate=1.0f/192000.0f;	// 1.0/192.0 KHz
const float kInvMinSampleRate=1.0f/1000.0f;		//1.0/1000.0

const float kMaxInt16Value = 32768.0f;
const float kInvMaxInt16 = 1.0f/32768.0f;
const float kDC_Offset=1e-12f;

// Demo constants
const Int32	kAudibleCount = 441000;
const Int32	kSilentCount = 44100;


inline void ZeroBuffer(float *BufferPointer, Int32 BufferSize)

{

	Int32 i;

	for(i=0;i<BufferSize;i++) { BufferPointer[i]=0.0; }

}



inline void ZeroBuffer(double *BufferPointer, Int32 BufferSize)

{

	for(Int32 i=0;i<BufferSize;i++) { BufferPointer[i]=0.0; }

}




