#import "MIBlueWindowController.h"
#import "MIBlueWindowParamController.h"

#ifndef TArmeWSObj_h
#include "TArmeWSObj.h"
#endif //TArmeWSObj_h

#ifndef VARPIPluginClass_h
#include "VARPIPluginClass.h"
#endif VARPIPluginClass_h

@implementation MIBlueWindowController

- (void)setWSObject:(TArmeWSObj*)obj
{
	if ( !obj )
	{
		verntl(interfaceStephan,0,"Null host passed to MIBlueWindowController, aborting.");
		return;
	}
	
	// $$$ remove the self there and put something else
	fParameters = [[NSMutableArray alloc] initWithObjects:nil];
	fWSObject = obj;
	fNumParams = fPluginClass->GetNbParams();
	
}

- (void)setHost:(TARPIHost*)host pluginClass:(VARPIPluginClass*)pluginClass
{
	if ( !host )
	{
		verntl(interfaceStephan,0,"Null host passed to MIBlueWindowController, aborting.");
		return;
	}
	
	if ( !pluginClass )
	{
		verntl(interfaceStephan,0,"Null plugin class passed to MIBlueWindowController, aborting.");
		return;
	}
	
	
	// $$$ remove the self there and put something else
	fHost = host;
	fPlugin = fHost->GetPlugin(self);	
	fNumParams = fWObj->GetPluginClass()->GetNbParams();
	
}

- (void)initialize
{
	int i;
	
	for ( i = 0 ; i < fNumParams ; i++ )
	{
		[self addParameter:i];
	}
	[fBlueWindowView setAutoresizingMask:NSViewHeightSizable|NSViewWidthSizable];
	[[self window] setMinSize:[[self window] frame].size];
}

- (void)syncValuesFromPlugin
{
	NSEnumerator					*paramEnum = nil;
	MIBlueWindowParamController		*aCtrl;

	while ( aCtrl = [paramEnum nextObject] )
		[aCtrl syncValuesFromPlugin];
}

- (void)syncPluginFromValues
{
	NSEnumerator					*paramEnum = nil;
	MIBlueWindowParamController		*aCtrl;

	while ( aCtrl = [paramEnum nextObject] )
		[aCtrl syncPluginFromValue];
}

- (MIBlueWindowParamController*)addParameter:(int)i
{
	MIBlueWindowParamController		*aParamCtrl;
	NSSize							contentSize;
	NSRect							contentRect;
	float							pos;
	
	aParamCtrl = [[MIBlueWindowParamController alloc] init];	
	[NSBundle loadNibNamed:@"MIBlueWindowParameter" owner:aParamCtrl];

	contentRect =[[[self window] contentView] bounds];
	contentSize = contentRect.size;
	pos = NSMaxY([fBlueWindowView frame]);
	
	// change the size
	contentSize.height += NSHeight([aParamCtrl->fView bounds]);
	[[self window] setContentSize:contentSize];

	// put the view in the right place
	[[[self window] contentView] addSubview:aParamCtrl->fView];
	[aParamCtrl->fView setFrameOrigin:NSMakePoint([fBlueWindowView frame].origin.y,pos)];
	[aParamCtrl->fView setFrameSize:NSMakeSize(NSWidth([fBlueWindowView frame]), NSHeight([aParamCtrl->fView frame]))];
	
	// tmp
	contentRect = [aParamCtrl->fView frame];
	
	// initialize the view
	[aParamCtrl setBlueWindowController:self];
	[aParamCtrl setParameterNumber:i];
	[aParamCtrl initialize];
	
	[fParameters addObject:aParamCtrl];
	
	return aParamCtrl;
}

- (NSString*)getNameForParam:(int)paramNumber
{
	ARPIParamInfo paramInfo;
	
	fPluginClass->GetParamInfo(&paramInfo, paramNumber);
	return [NSString stringWithCString:paramInfo.name];	
}

- (float)getMinValueForParam:(int)paramNumber
{
	ARPIParamInfo paramInfo;
	
	fPluginClass->GetParamInfo(&paramInfo, paramNumber);
	return paramInfo.minVal;	
}

- (float)getMaxValueForParam:(int)paramNumber
{
	ARPIParamInfo paramInfo;
	
	fPluginClass->GetParamInfo(&paramInfo, paramNumber);
	return paramInfo.maxVal;	
}

- (float)getValueForParam:(int)paramNumber
{
	return fPlugin->GetParamValue(paramNumber);
}

- (void)setValue:(float)value forParam:(int)paramNumber
{
	fPlugin->SetParamValue(paramNumber, value);
	[[fParameters objectAtIndex:paramNumber] syncValuesFromPlugin];
}

- (void)newBlueWindowVPos:(float)vPos
{
	NSEnumerator					*paramEnum;
	MIBlueWindowParamController		*aCtrl;
	
	paramEnum = [fParameters objectEnumerator];
	
	while ( aCtrl = [paramEnum nextObject] )
	{
		[aCtrl reflectBlueWindowVPos:vPos];
	}
}

- (void)newBlueWindowHPos:(float)hPos
{
	NSEnumerator					*paramEnum;
	MIBlueWindowParamController		*aCtrl;
	
	paramEnum = [fParameters objectEnumerator];

	while ( aCtrl = [paramEnum nextObject] )
	{
		[aCtrl reflectBlueWindowHPos:hPos];
	}
}

@end
