/****************************************************************************
 *   Copyright (C) 2004 by Arboretum Systems, Inc.                          *
 *   Technical administrator: Alain Mazy, hav@mazy.be                       *
 *   Lead program designer: Georges Jaroslaw, gjaro@arboretum.com           *
 *                                                                          *
 *   HyperEngine-AV is a video, audio and text editor that can be used to   *
 *   record, import, edit, process and arrange together video, sound and    *
 *   text. These are all achieved in the program's free-form document       *
 *   window, with no limitations to the number of tracks.                   *
 *   The purpose of this program is to provide to users at all levels of    *
 *   expertise a readily accessible tool enabling them to create movies,    *
 *   slide shows or presentations.                                          *
 *                                                                          *
 *   HyperEngine-AV itself is free software. However, plug-ins that can be  *
 *   used as add-ons to HyperEngine-AV may or may not be free software, at  *
 *   the discretion of each plug-in developer and as specified by these     *
 *   plug-ins' respective licenses.                                         *
 *   You can redistribute HyperEngine-AV itself and/or modify it under the  *
 *   terms of the GNU General Public License as published by the Free       *
 *   Software Foundation; either version 2 of the License, or (at your      *
 *   option) any later version.                                             *
 *                                                                          *
 *   HyperEngine-AV is distributed in the hope that it will be useful, but  *
 *   WITHOUT ANY WARRANTY; without even the implied warranty of             *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the          *
 *   GNU General Public License for all applicable details.                 *
 *                                                                          *
 *   You should have received a copy of the GNU General Public License      *
 *   along with this program; if not, write to:                             *
 *   Free Software Foundation, Inc.,                                        *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.              *
 ****************************************************************************/
#import "MontageInterface.h"
#import "ARPI.h"

enum MIBlueWindowLink
{
	MIBlueWindowLinkNone = 0,
	MIBlueWindowLinkLeftRight,
	MIBlueWindowLinkUpDown,
	MIBlueWindowLinkRightLeft,
	MIBlueWindowLinkDownUp,
	MIMaxBlueWindowLinkTypes
};

@class MIBlueWindowController;

@interface MIBlueWindowParamController : NSObject
{
    IBOutlet id 				fMaxParamValue;
    IBOutlet id 				fMinParamValue;
    IBOutlet id 				fParamButton;
    IBOutlet id 				fParamCurrentValue;
    IBOutlet id 				fParamSlider;
    IBOutlet id 				fParamTitle;
    IBOutlet id 				fView;
	MIBlueWindowController		*fController;
	int							fParamNumber;
	int							fLinkType;
	NSImage						*fLinkButtonImages[MIMaxBlueWindowLinkTypes];
}

- (void)setBlueWindowController:(MIBlueWindowController*)blueWindowController;
- (void)setParameterNumber:(int)number;
- (void)initialize;

- (float)getValue;

- (void)syncValuesFromPlugin;
- (void)syncPluginFromValue;
- (void)sendValueToPlugin:(float)value;


- (IBAction)currentValueChanged:(id)sender;
- (IBAction)paramButtonClicked:(id)sender;
- (IBAction)paramSliderMoved:(id)sender;

- (void)reflectBlueWindowVPos:(float)vPos;
- (void)reflectBlueWindowHPos:(float)hPos;
@end
