/****************************************************************************
 *   Copyright (C) 2004 by Arboretum Systems, Inc.                          *
 *   Technical administrator: Alain Mazy, hav@mazy.be                       *
 *   Lead program designer: Georges Jaroslaw, gjaro@arboretum.com           *
 *                                                                          *
 *   HyperEngine-AV is a video, audio and text editor that can be used to   *
 *   record, import, edit, process and arrange together video, sound and    *
 *   text. These are all achieved in the program's free-form document       *
 *   window, with no limitations to the number of tracks.                   *
 *   The purpose of this program is to provide to users at all levels of    *
 *   expertise a readily accessible tool enabling them to create movies,    *
 *   slide shows or presentations.                                          *
 *                                                                          *
 *   HyperEngine-AV itself is free software. However, plug-ins that can be  *
 *   used as add-ons to HyperEngine-AV may or may not be free software, at  *
 *   the discretion of each plug-in developer and as specified by these     *
 *   plug-ins' respective licenses.                                         *
 *   You can redistribute HyperEngine-AV itself and/or modify it under the  *
 *   terms of the GNU General Public License as published by the Free       *
 *   Software Foundation; either version 2 of the License, or (at your      *
 *   option) any later version.                                             *
 *                                                                          *
 *   HyperEngine-AV is distributed in the hope that it will be useful, but  *
 *   WITHOUT ANY WARRANTY; without even the implied warranty of             *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the          *
 *   GNU General Public License for all applicable details.                 *
 *                                                                          *
 *   You should have received a copy of the GNU General Public License      *
 *   along with this program; if not, write to:                             *
 *   Free Software Foundation, Inc.,                                        *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.              *
 ****************************************************************************/

#import <AppKit/AppKit.h>

// DV device control stuff
#include <DVComponentGlue/IsochronousDataHandler.h>
#include <DVComponentGlue/DeviceControl.h>
#include <iokit/IOKitLib.h>
// from ISOCHRONOUS COMPONENTS REFERENCE v1.0 3/16/2001
#define kIDHComponentType 	'ihlr'		/* Component type*/
#define	kIDHSubtypeDV		'dv  '		/* Subtype for DV (over FireWire)*/

typedef enum {
    devicePlay				= 0x0020C375,
    deviceRewind			= 0x0020C465,
    deviceRewindPlay		= 0x0020C34F,
    deviceFastForward		= 0x0020C475,
    deviceFastForwardPlay	= 0x0020C33F,
    deviceStop				= 0x0020C460,
    devicePause				= 0x0020C37D,
    deviceNextFrame			= 0x0020C330,
    deviceSlowForward		= 0x0020C335,
    devicePreviousFrame		= 0x0020C340,
    deviceSlowRewind		= 0x0020C345,
    deviceQuery				= 0x0120D07F,
    deviceTime				= 0x01205171,
	deviceCameraRec			= 0x0020C27D,
	deviceRecordOnCamera	= 0x0020C275  //used when exporting video to camera
} ControlFrame;


@interface MICamera : NSObject {

	ComponentInstance	fDVCamera;
	QTAtomSpec			fCameraConfig;
//	IDHNotificationID	fNotificationID;
}
+ (BOOL)isCameraConnected;

- (id)init;//WithNotification:(BOOL)withNotification;
- (void)close;
- (int)deviceControl:(int)command;

//- (IDHNotificationID)notificationID;
- (ComponentInstance)cameraComponent;

@end
