/****************************************************************************
 *   Copyright (C) 2004 by Arboretum Systems, Inc.                          *
 *   Technical administrator: Alain Mazy, hav@mazy.be                       *
 *   Lead program designer: Georges Jaroslaw, gjaro@arboretum.com           *
 *                                                                          *
 *   HyperEngine-AV is a video, audio and text editor that can be used to   *
 *   record, import, edit, process and arrange together video, sound and    *
 *   text. These are all achieved in the program's free-form document       *
 *   window, with no limitations to the number of tracks.                   *
 *   The purpose of this program is to provide to users at all levels of    *
 *   expertise a readily accessible tool enabling them to create movies,    *
 *   slide shows or presentations.                                          *
 *                                                                          *
 *   HyperEngine-AV itself is free software. However, plug-ins that can be  *
 *   used as add-ons to HyperEngine-AV may or may not be free software, at  *
 *   the discretion of each plug-in developer and as specified by these     *
 *   plug-ins' respective licenses.                                         *
 *   You can redistribute HyperEngine-AV itself and/or modify it under the  *
 *   terms of the GNU General Public License as published by the Free       *
 *   Software Foundation; either version 2 of the License, or (at your      *
 *   option) any later version.                                             *
 *                                                                          *
 *   HyperEngine-AV is distributed in the hope that it will be useful, but  *
 *   WITHOUT ANY WARRANTY; without even the implied warranty of             *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the          *
 *   GNU General Public License for all applicable details.                 *
 *                                                                          *
 *   You should have received a copy of the GNU General Public License      *
 *   along with this program; if not, write to:                             *
 *   Free Software Foundation, Inc.,                                        *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.              *
 ****************************************************************************/
#import "MontageInterface.h"

@class MIDockableItem;

@interface MIDockBar : NSView
{
	IBOutlet id		applicationController;
	BOOL			_isInMainView;
	BOOL			_isMinimized;
	NSMutableArray	*_rows;
	// the DockableItems are disposed this way:
	// the rows Array contains another array with pointers to the relevant subviews (the dockable items)
}
- (BOOL)isInMainView;
- (void)setIsInMainView:(BOOL)flag;
- (BOOL)isMinimized;
- (BOOL)isEmpty;

- (void)expand;
- (void)minimize;

// this function will display the impact on other dockitems if the item is inserted
- (void)prepareToDockItem:(MIDockableItem*)item atPos:(NSPoint)pos;
- (NSPoint)insertDockableItem:(MIDockableItem*)item inRow:(unsigned int)rowNbr atPos:(unsigned int)pos;
// this function will display the impact on other dockitems if the item is removed
- (void)prepareToRemoveItem:(MIDockableItem*)item;
- (void)removeDockableItem:(MIDockableItem*)item;

- (NSRect)rearrangeItemsWithNewItem:(MIDockableItem*)newItem;
- (NSRect)rearrangeItems;

// the point returned by this function is a position of the form
// ( 2.5, 1), which means "the location is in the first line, right after item number 2
- (NSPoint)findAppropriateLocationForItem:(MIDockableItem*)item atPos:(NSPoint)pos;
@end
