/****************************************************************************
 *   Copyright (C) 2004 by Arboretum Systems, Inc.                          *
 *   Technical administrator: Alain Mazy, hav@mazy.be                       *
 *   Lead program designer: Georges Jaroslaw, gjaro@arboretum.com           *
 *                                                                          *
 *   HyperEngine-AV is a video, audio and text editor that can be used to   *
 *   record, import, edit, process and arrange together video, sound and    *
 *   text. These are all achieved in the program's free-form document       *
 *   window, with no limitations to the number of tracks.                   *
 *   The purpose of this program is to provide to users at all levels of    *
 *   expertise a readily accessible tool enabling them to create movies,    *
 *   slide shows or presentations.                                          *
 *                                                                          *
 *   HyperEngine-AV itself is free software. However, plug-ins that can be  *
 *   used as add-ons to HyperEngine-AV may or may not be free software, at  *
 *   the discretion of each plug-in developer and as specified by these     *
 *   plug-ins' respective licenses.                                         *
 *   You can redistribute HyperEngine-AV itself and/or modify it under the  *
 *   terms of the GNU General Public License as published by the Free       *
 *   Software Foundation; either version 2 of the License, or (at your      *
 *   option) any later version.                                             *
 *                                                                          *
 *   HyperEngine-AV is distributed in the hope that it will be useful, but  *
 *   WITHOUT ANY WARRANTY; without even the implied warranty of             *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the          *
 *   GNU General Public License for all applicable details.                 *
 *                                                                          *
 *   You should have received a copy of the GNU General Public License      *
 *   along with this program; if not, write to:                             *
 *   Free Software Foundation, Inc.,                                        *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.              *
 ****************************************************************************/
#import "MontageInterface.h"

/*
	The purpose of this class is to make the palettes sticky to one another and to the mainview
*/

enum MIPanelType
{
	MIOverviewPanel = 0,
	MITimePanel,
	MIPlayStopPausePanel,
//	MIToolBoxPanel,
	MIMainWindowPanel,
	MINoPanel,
};

#define kNumPanels 4
#define kStickyPanelsThreshold 20
#define kSpaceBetweenPanels	4

@interface MIPaletteLayoutManager : NSObject
{
	IBOutlet id			fMainWindow;
	NSWindow			*fPanels[kNumPanels];
	MIPanelType			fPanelSticksTo[kNumPanels][4]; // one for each edge of each panel.
	NSRectEdge			fPanelSticksToEdge[kNumPanels];
}

- (void)setPanel:(NSWindow*)panelWindow ofType:(MIPanelType)type;
- (void)mainWindowMoved:(NSNotification*)notification;
- (void)mainWindowResized:(NSNotification*)notification;
- (void)panelMoved:(NSNotification*)notification;
- (void)panelResized:(NSNotification*)notification;
- (void)reinitNotifications;
- (void)makePanelsStickyFrom:(MIPanelType)panel;
- (void)checkPanelsStickyness;
- (BOOL)coord:(float)coord sticksTo:(float)otherCoord;
@end
