/****************************************************************************
 *   Copyright (C) 2004 by Arboretum Systems, Inc.                          *
 *   Technical administrator: Alain Mazy, hav@mazy.be                       *
 *   Lead program designer: Georges Jaroslaw, gjaro@arboretum.com           *
 *                                                                          *
 *   HyperEngine-AV is a video, audio and text editor that can be used to   *
 *   record, import, edit, process and arrange together video, sound and    *
 *   text. These are all achieved in the program's free-form document       *
 *   window, with no limitations to the number of tracks.                   *
 *   The purpose of this program is to provide to users at all levels of    *
 *   expertise a readily accessible tool enabling them to create movies,    *
 *   slide shows or presentations.                                          *
 *                                                                          *
 *   HyperEngine-AV itself is free software. However, plug-ins that can be  *
 *   used as add-ons to HyperEngine-AV may or may not be free software, at  *
 *   the discretion of each plug-in developer and as specified by these     *
 *   plug-ins' respective licenses.                                         *
 *   You can redistribute HyperEngine-AV itself and/or modify it under the  *
 *   terms of the GNU General Public License as published by the Free       *
 *   Software Foundation; either version 2 of the License, or (at your      *
 *   option) any later version.                                             *
 *                                                                          *
 *   HyperEngine-AV is distributed in the hope that it will be useful, but  *
 *   WITHOUT ANY WARRANTY; without even the implied warranty of             *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the          *
 *   GNU General Public License for all applicable details.                 *
 *                                                                          *
 *   You should have received a copy of the GNU General Public License      *
 *   along with this program; if not, write to:                             *
 *   Free Software Foundation, Inc.,                                        *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.              *
 ****************************************************************************/#if 0 //$$$TOOLBOX

#import "MIToolBoxController.h"
#import "MIApplicationController.h"
#import "MIImageController.h"
#import "MIMainViewController.h"
#import "MIPaletteController.h"
#import "MIApplication.h"

@implementation MIToolBoxController

+ (NSString*)visibleDefaultName {
    return @"ToolBoxVisible";
}

- (NSString*)nibName {
    return @"ToolBox";
}

- (int)menuTag {
	return 0;
}

- (NSString*)menuName {
	return @"ToolBox";
}

+ (MIToolBoxController*)sharedToolBoxController
{
    static id sharedToolBoxController;
    if ( sharedToolBoxController == nil )
    {
        sharedToolBoxController = [[self alloc] init];
    }
    return sharedToolBoxController;    
}

- (id)init
{
    if (( self = [super init] ))
    {
    }
    
    return self;
}

- (void)dealloc
{
    [super dealloc];
}

- (void)awakeFromNib
{
    [self setImages];
}

- (void)setImages
{
    [audioButton setImage:mainImageController->fToolBoxButtonAudioOff];
    [audioButton setAlternateImage:mainImageController->fToolBoxButtonAudioOn];
    [clipboardButton setImage:mainImageController->fToolBoxButtonClipBoardOff];
    [clipboardButton setAlternateImage:mainImageController->fToolBoxButtonClipBoardOn];
    [gridButton setImage:mainImageController->fToolBoxButtonGridOff];
    [gridButton setAlternateImage:mainImageController->fToolBoxButtonGridOn];
    [historyButton setImage:mainImageController->fToolBoxButtonHistoryOff];
    [historyButton setAlternateImage:mainImageController->fToolBoxButtonHistoryOn];
    [midiButton setImage:mainImageController->fToolBoxButtonMidiOff];
    [midiButton setAlternateImage:mainImageController->fToolBoxButtonMidiOn];
    [mixerButton setImage:mainImageController->fToolBoxButtonMixerOff];
    [mixerButton setAlternateImage:mainImageController->fToolBoxButtonMixerOn];
    [processorButton setImage:mainImageController->fToolBoxButtonProcessorOff];
    [processorButton setAlternateImage:mainImageController->fToolBoxButtonProcessorOn];
    [searchButton setImage:mainImageController->fToolBoxButtonSearchOff];
    [searchButton setAlternateImage:mainImageController->fToolBoxButtonSearchOn];
    [textButton setImage:mainImageController->fToolBoxButtonTextOff];
    [textButton setAlternateImage:mainImageController->fToolBoxButtonTextOn];
    [videoButton setImage:mainImageController->fToolBoxButtonVideoOff];
    [videoButton setAlternateImage:mainImageController->fToolBoxButtonVideoOn];

    [alignmentButton setImage:mainImageController->fToolBoxButtonAlignmentOff];
    [alignmentButton setAlternateImage:mainImageController->fToolBoxButtonAlignmentOn];
    [chainButton setImage:mainImageController->fToolBoxButtonChainOff];
    [chainButton setAlternateImage:mainImageController->fToolBoxButtonChainOn];
    [colorizeButton setImage:mainImageController->fToolBoxButtonColorizeOff];
    [colorizeButton setAlternateImage:mainImageController->fToolBoxButtonColorizeOn];
    [lockButton setImage:mainImageController->fToolBoxButtonLockOff];
    [lockButton setAlternateImage:mainImageController->fToolBoxButtonLockOn];
    [markerButton setImage:mainImageController->fToolBoxButtonMarkerOff];
    [markerButton setAlternateImage:mainImageController->fToolBoxButtonMarkerOn];
    [packButton setImage:mainImageController->fToolBoxButtonPackOff];
    [packButton setAlternateImage:mainImageController->fToolBoxButtonPackOn];
    [snapButton setImage:mainImageController->fToolBoxButtonSnapOff];
    [snapButton setAlternateImage:mainImageController->fToolBoxButtonSnapOn];
    [sortButton setImage:mainImageController->fToolBoxButtonSortOff];
    [sortButton setAlternateImage:mainImageController->fToolBoxButtonSortOn];
    
}

- (BOOL)canBecomeKeyWindow
{
    return NO;
}

- (BOOL)canBecomeMainWindow
{
    return NO;
}

- (void)popUpMenu:(NSMenu*)menu forButton:(id)button
{
    NSEvent 			*theEvent;

/*    theEvent = [NSEvent mouseEventWithType:NSLeftMouseDown location:[[sender object] frame].origin
                modifierFlags:0 timestamp:(NSTimeInterval)time windowNumber:(int)windowNum
                context:(NSGraphicsContext *)context eventNumber:(int)eventNumber
                clickCount:1 pressure:1];
    [NSMenu popUpContextMenu:fGridMenu withEvent:theEvent forView:[sender object]];*/
	

    theEvent = [NSEvent mouseEventWithType:NSLeftMouseDown location:[button frame].origin
                modifierFlags:0 timestamp:0 windowNumber:[[self window] windowNumber]
                context:[NSGraphicsContext currentContext] eventNumber:1
                clickCount:1 pressure:1];

	
    [NSMenu popUpContextMenu:menu withEvent:theEvent forView:button];
	
}





- (IBAction)audioButtonPressed:(id)sender
{
}

- (IBAction)clipBoardButtonPressed:(id)sender
{
}

- (IBAction)gridButtonPressed:(id)sender
{
    NSEnumerator		*theEnum;
	NSMenuItem			*anItem;
	unsigned int		gridFlags;
	
	theEnum = [[fGridMenu itemArray] objectEnumerator];
	gridFlags = [[NSApp mainViewController] gridFlags];

	while ( anItem = [theEnum nextObject] )
	{
		if ( gridFlags & [anItem tag] )
			[anItem setState:NSOnState];
		else
			[anItem setState:NSOffState];	
	}
	
	[self popUpMenu:fGridMenu forButton:sender];
}

- (IBAction)gridMenuItemPressed:(id)sender
{
	unsigned int	gridFlags;
	
	gridFlags = [[NSApp mainViewController] gridFlags];
	
	if ( [sender tag] )
	{
		// toggle the flag
		gridFlags ^= [sender tag];
	}
	if ( gridFlags & [sender tag] )
		[sender setState:NSOnState];
	else
		[sender setState:NSOffState];
	
	[[NSApp mainViewController] setGridFlags:gridFlags];
}


- (IBAction)historyButtonPressed:(id)sender
{
}

- (IBAction)midiButtonPressed:(id)sender
{
}

- (IBAction)mixerButtonPressed:(id)sender
{
}

- (IBAction)processorButtonPressed:(id)sender
{
	[self popUpMenu:[[MIApplicationController sharedApplicationController]->fProcessorMenuItem submenu] forButton:sender];
}

- (IBAction)searchButtonPressed:(id)sender
{
}

- (IBAction)textButtonPressed:(id)sender
{
}

- (IBAction)videoButtonPressed:(id)sender
{
}

- (IBAction)alignmentButtonPressed:(id)sender
{
}

- (IBAction)chainButtonPressed:(id)sender
{
}

- (IBAction)colorizeButtonPressed:(id)sender
{
}

- (IBAction)lockButtonPressed:(id)sender
{
}

- (IBAction)markerButtonPressed:(id)sender
{
}

- (IBAction)packButtonPressed:(id)sender
{
}

- (IBAction)snapButtonPressed:(id)sender
{
}

- (IBAction)sortButtonPressed:(id)sender
{
}



@end

#endif // 0 //$$$TOOLBOX
