/****************************************************************************
 *   Copyright (C) 2004 by Arboretum Systems, Inc.                          *
 *   Technical administrator: Alain Mazy, hav@mazy.be                       *
 *   Lead program designer: Georges Jaroslaw, gjaro@arboretum.com           *
 *                                                                          *
 *   HyperEngine-AV is a video, audio and text editor that can be used to   *
 *   record, import, edit, process and arrange together video, sound and    *
 *   text. These are all achieved in the program's free-form document       *
 *   window, with no limitations to the number of tracks.                   *
 *   The purpose of this program is to provide to users at all levels of    *
 *   expertise a readily accessible tool enabling them to create movies,    *
 *   slide shows or presentations.                                          *
 *                                                                          *
 *   HyperEngine-AV itself is free software. However, plug-ins that can be  *
 *   used as add-ons to HyperEngine-AV may or may not be free software, at  *
 *   the discretion of each plug-in developer and as specified by these     *
 *   plug-ins' respective licenses.                                         *
 *   You can redistribute HyperEngine-AV itself and/or modify it under the  *
 *   terms of the GNU General Public License as published by the Free       *
 *   Software Foundation; either version 2 of the License, or (at your      *
 *   option) any later version.                                             *
 *                                                                          *
 *   HyperEngine-AV is distributed in the hope that it will be useful, but  *
 *   WITHOUT ANY WARRANTY; without even the implied warranty of             *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the          *
 *   GNU General Public License for all applicable details.                 *
 *                                                                          *
 *   You should have received a copy of the GNU General Public License      *
 *   along with this program; if not, write to:                             *
 *   Free Software Foundation, Inc.,                                        *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.              *
 ****************************************************************************/
#import "MITransportController.h"
#import "MITime.h"
#import "MIMainViewController.h"

@implementation MITransportController
-(void)setMainViewController:(MIMainViewController*)theMainViewController
{
	fMainViewController = theMainViewController;
}

-(MIMainViewController*)mainViewController
{
	return fMainViewController;
}

- (NSView*)transportView
{
	return fTransportView;
}

- (void)updateTransportWithController:(MIMainViewController*)aMainViewController
{
	[self setMainViewController:aMainViewController];
	[self updateParameters];
}

- (void)updateParameters
{
	MITime		*s;
	MITime		*e;
	MITime		*d;
	
//	int			vFR, aFR;
	
	s = [[[MITime alloc] init] autorelease];
	e = [[[MITime alloc] init]  autorelease];
	d = [[[MITime alloc] init] autorelease];

//	aFR = ArmeDocGetAudioFrameRate([mainViewController armeDocument]);
//	vFR = ArmeDocGetVideoFrameRate([mainViewController armeDocument]);

/*
	[s setAudioFrameRate:aFR];	
	[s setVideoFrameRate:vFR];
	[e setAudioFrameRate:aFR];	
	[e setVideoFrameRate:vFR];
	[d setAudioFrameRate:aFR];	
	[d setVideoFrameRate:vFR];
*/

//	[s setArmeTime:ArmeDocGetPlayStartPos([mainViewController armeDocument])];
	[fStartHBox setIntValue:[s getHours]];
	[fStartMBox setIntValue:[s getMinutes]];
	[fStartSBox setIntValue:[s getSeconds]];
	[fStartFrBox setIntValue:[s getVideoFrames]];
	[fStartMsBox setIntValue:[s getMiliseconds]];

//	[e setArmeTime:ArmeDocGetPlayEndPos([mainViewController armeDocument])];
	[fEndHBox setIntValue:[e getHours]];
	[fEndMBox setIntValue:[e getMinutes]];
	[fEndSBox setIntValue:[e getSeconds]];
	[fEndFrBox setIntValue:[e getVideoFrames]];
	[fEndMsBox setIntValue:[e getMiliseconds]];

	[d setDoubleTime:[e getDoubleTime]];
	[d subTime:s];
		
	[fDurationHBox setIntValue:[d getHours]];
	[fDurationMBox setIntValue:[d getMinutes]];
	[fDurationSBox setIntValue:[d getSeconds]];
	[fDurationFrBox setIntValue:[d getVideoFrames]];
	[fDurationMsBox setIntValue:[d getMiliseconds]];
}

- (IBAction)startBoxChanged:(id)sender
{
}

- (IBAction)durationBoxChanged:(id)sender
{
}

- (IBAction)endBoxChanged:(id)sender
{
}

@end
