//
//  MIVideoController.h
//  Montage
//
//  Created by Marc Palluat de Besset on Fri Mar 29 2002.
//  Copyright (c) 2002 Arboretum Systems, Inc.. All rights reserved.
//

#import <AppKit/AppKit.h>
#import "MIVideoWindow.h"
#import "MIMontageDocument.h"
#import "MIPaletteController.h"

@interface MIVideoController : NSObject {
    // the windows where video is played
    MIVideoWindow				*fBackstageVideoWindow;
    MIFullScreenVideoWindow			*fFullScreenVideoWindow;

    // caches for menu items that reflect active video window
    NSMenuItem* 				fHalfSizeMenuItem;
    NSMenuItem* 				fNormalSizeMenuItem;
    NSMenuItem* 				fDoubleSizeMenuItem;
    NSMenuItem* 				fFullScreenMenuItem;
	NSMenuItem* 				fActiveMenuItem;
}

+ (void)addDefaultValuesToDictionary:(NSMutableDictionary*)defaultValues;

+ (MIVideoController*)sharedVideoController ;
- (MIVideoController*)init ;
- (void)dealloc ;

- (void)currentDocumentChanged:(NSNotification*)notification ;
- (void)setActiveDocument:(MIMontageDocument*)activeDocument ;

- (IBAction)showBackstage:(id)sender;
- (IBAction)viewTheater:(id)sender;
- (void)viewBackstage:(float)magnification;
- (IBAction)viewBackstageHalfx:(id)sender;
- (IBAction)viewBackstage1x:(id)sender;
- (IBAction)viewBackstage2x:(id)sender;
- (IBAction)viewBackstage4x:(id)sender;

- (IBAction)restoreBackstageView:(id)sender;

- (IBAction)show:(id)sender;
- (IBAction)hide:(id)sender;
- (BOOL)isVisible;
- (IBAction)toggleShowHide:(id)sender;

- (void)saveUserDefaults:(BOOL)shouldBeVisible;
- (NSString*)nibName;

- (float)magnification;

@end
