/****************************************************************************
 *   Copyright (C) 2004 by Arboretum Systems, Inc.                          *
 *   Technical administrator: Alain Mazy, hav@mazy.be                       *
 *   Lead program designer: Georges Jaroslaw, gjaro@arboretum.com           *
 *                                                                          *
 *   HyperEngine-AV is a video, audio and text editor that can be used to   *
 *   record, import, edit, process and arrange together video, sound and    *
 *   text. These are all achieved in the program's free-form document       *
 *   window, with no limitations to the number of tracks.                   *
 *   The purpose of this program is to provide to users at all levels of    *
 *   expertise a readily accessible tool enabling them to create movies,    *
 *   slide shows or presentations.                                          *
 *                                                                          *
 *   HyperEngine-AV itself is free software. However, plug-ins that can be  *
 *   used as add-ons to HyperEngine-AV may or may not be free software, at  *
 *   the discretion of each plug-in developer and as specified by these     *
 *   plug-ins' respective licenses.                                         *
 *   You can redistribute HyperEngine-AV itself and/or modify it under the  *
 *   terms of the GNU General Public License as published by the Free       *
 *   Software Foundation; either version 2 of the License, or (at your      *
 *   option) any later version.                                             *
 *                                                                          *
 *   HyperEngine-AV is distributed in the hope that it will be useful, but  *
 *   WITHOUT ANY WARRANTY; without even the implied warranty of             *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the          *
 *   GNU General Public License for all applicable details.                 *
 *                                                                          *
 *   You should have received a copy of the GNU General Public License      *
 *   along with this program; if not, write to:                             *
 *   Free Software Foundation, Inc.,                                        *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.              *
 ****************************************************************************/
#import <Cocoa/Cocoa.h>
#import <Quicktime/Quicktime.h>

#import "MIVideoEffectRep.h"
#import "MIImageController.h"
#import "MIObject.h"
#import "MIApplicationController.h"
#import "TVideoEffect.h"
#import "MITopLevelContainerRep.h"
#import "MIMainViewController.h"
#import "MIWSSelection.h"


@implementation MIVideoEffectRep
- (id)initWithFrame:(NSRect)frame inTLC:(MITopLevelContainerRep*)theTLC
{
    self = [super initWithFrame:frame inTLC:theTLC];

//    fLeftBarImage = mainImageController->fContainerProcessorBarOnLeft;
//    fCenterBarImage = mainImageController->fContainerProcessorBarOnCenter;
//    fRightBarImage = mainImageController->fContainerProcessorBarOnRight;


    return self;
}

- (void)setImagesAndColor
{
	if ( [self isSelected] && [[[fTLCRep mainViewController] selection] type] == kMIWSSelectionTypeObjects )
	{
		[self setBackgroundColor:mainImageController->fProcessorNegativeColor];
		fLeftTitleImage = mainImageController->fLeftProcessorNegativeTitleBarImage;
		fCenterTitleImage = mainImageController->fCenterProcessorNegativeTitleBarImage;
		fRightTitleImage = mainImageController->fRightProcessorNegativeTitleBarImage;
	}
	else if ( [fRepresentedObject isMuted] )
	{
		[self setBackgroundColor:mainImageController->fProcessorDimColor];
		fLeftTitleImage = mainImageController->fLeftProcessorDimTitleBarImage;
		fCenterTitleImage = mainImageController->fCenterProcessorDimTitleBarImage;
		fRightTitleImage = mainImageController->fRightProcessorDimTitleBarImage;
	}
	else 
	{
		[self setBackgroundColor:mainImageController->fProcessorBrightColor];
		fLeftTitleImage = mainImageController->fLeftProcessorBrightTitleBarImage;
		fCenterTitleImage = mainImageController->fCenterProcessorBrightTitleBarImage;
		fRightTitleImage = mainImageController->fRightProcessorBrightTitleBarImage;
	}
}

- (BOOL)doubleClick:(NSPoint)mouseLoc modifier:(unsigned int)modifier
{
	if ( NSPointInRect(mouseLoc, [self rectForZone:MIObjectRepTitleZone]) ||
		 NSPointInRect(mouseLoc, [self rectForZone:MIObjectRepDragBarZone]) )
	{
		[self showProperties];
		return YES;
	}
	
	return NO;
}

- (void)showProperties
{
/*	TVideoEffect* videoEffect = (TVideoEffect*)[[self representedObject] WSObject];

	videoEffect->Configure();*/
	
	vertl(commandsBenjamin,5,"INFO : the 'configure video effect' menu entry has been selected (by double-clicking the object).\n");
	[[NSApp mainViewController] executeCommand:@"configureVideoEffect" ];	
}


@end
