//
//  MIVideoWindow.h
//  Montage
//
//  Created by alainm on Sat Nov 17 2001.
//  Copyright (c) 2001-2002 Arboretum. All rights reserved.
//

#import <Cocoa/Cocoa.h>
#import <Quicktime/Quicktime.h>

@interface MIVideoWindow : NSPanel 
{
@public
	NSMovieView*	fMovieView;
	NSMovie*	fMovie;
	Movie		fQTMovie;
        NSTrackingRectTag fTrackingRect;
        float		fMagnification;
        /*
	BOOL		fIsFullScreen;
        NSRect		fNormalFrame;
        */
}
- (id)initWithFrame:(NSRect)frameRect;

- (void)dealloc;
- (void)detachMovie;

- (void)attachMovie:(Movie)aMovie;

- (void)takeMovieView:(NSMovieView*)theMovieView;
- (NSMovieView*)giveMovieView;

- (void)setMagnification:(float)magnification;

/*
// returns full screen status. Note that attempting to enable it may fail if user cancels screen choice dialog.
- (BOOL)setFullScreen:(BOOL)isFullScreen;
- (BOOL)isFullScreen;
*/
@end

@interface MIFullScreenVideoWindow : MIVideoWindow 
{
}

- (id)initWithFrame:(NSRect)frameRect;
- (void)takeMovieViewAndFill:(NSMovieView*)theMovieView onScreen:(NSScreen*)theScreen;
- (BOOL)canBecomeKeyWindow;
- (void)keyDown:(NSEvent *)theEvent;
- (void)mouseDown:(NSEvent *)theEvent;
- (void)setTrackingRect:(BOOL)forHidingMenuBar;
- (void)mouseEntered:(NSEvent*)event;
//- (void)mouseExited:(NSEvent *)theEvent;

@end

@interface MIMovieView : NSMovieView {
}
@end
