/****************************************************************************
 *   Copyright (C) 2004 by Arboretum Systems, Inc.                          *
 *   Technical administrator: Alain Mazy, hav@mazy.be                       *
 *   Lead program designer: Georges Jaroslaw, gjaro@arboretum.com           *
 *                                                                          *
 *   HyperEngine-AV is a video, audio and text editor that can be used to   *
 *   record, import, edit, process and arrange together video, sound and    *
 *   text. These are all achieved in the program's free-form document       *
 *   window, with no limitations to the number of tracks.                   *
 *   The purpose of this program is to provide to users at all levels of    *
 *   expertise a readily accessible tool enabling them to create movies,    *
 *   slide shows or presentations.                                          *
 *                                                                          *
 *   HyperEngine-AV itself is free software. However, plug-ins that can be  *
 *   used as add-ons to HyperEngine-AV may or may not be free software, at  *
 *   the discretion of each plug-in developer and as specified by these     *
 *   plug-ins' respective licenses.                                         *
 *   You can redistribute HyperEngine-AV itself and/or modify it under the  *
 *   terms of the GNU General Public License as published by the Free       *
 *   Software Foundation; either version 2 of the License, or (at your      *
 *   option) any later version.                                             *
 *                                                                          *
 *   HyperEngine-AV is distributed in the hope that it will be useful, but  *
 *   WITHOUT ANY WARRANTY; without even the implied warranty of             *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the          *
 *   GNU General Public License for all applicable details.                 *
 *                                                                          *
 *   You should have received a copy of the GNU General Public License      *
 *   along with this program; if not, write to:                             *
 *   Free Software Foundation, Inc.,                                        *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.              *
 ****************************************************************************/

#define kCurrentVersion 0x00010035
// added the alias to reference audio files
//#define kCurrentVersion 0x00010034
// added collapsed groups fix
//#define kCurrentVersion 0x00010033
//added fIsReferenceToExternalFile in ArmeDataFileRef
//#define kCurrentVersion 0x00010032
// added fFixedParameters to TVideoXFadeEffect and TVideoXFadeEffectDesc 
//#define kCurrentVersion 0x00010031 
// modified for the new audio file referencing
//#define kCurrentVersion 0x00010030 
// updated the ArmeDataFileRef to support external references

//*************** Montage 1.0 has been released with file version = 0x0001002F.  It can also read doc from the last beta (internally distributed : 0x0001002E)

//#define kCurrentVersion 0x0001002F 
// optimized the text clips !

#define kMinimalVersion 0x0001002E
// added fOldTransitionsDesc to TArmeDoc

//#define kCurrentVersion 0x0001002D
//added fMementoAfter to MITimeStretchVideoCommand
//#define kCurrentVersion 0x0001002C
//added fDeleteOtherContainersCommand to MIDeleteContainerCommand
//#define kCurrentVersion 0x0001002B
//added fCreatedObject to MICreateWSObjsFromFile
//#define kCurrentVersion 0x0001002A
//added fMIContainer to MIConfigureVideoEffectCommand
//#define kCurrentVersion 0x00010029
//added fEnlargeCommand to MICreateClipFromFrame
//#define kCurrentVersion 0x00010028
// added fTextClipOwnerArray to TArmeMasterMovieChunk
//#define kCurrentVersion 0x00010027
// added new command + text clip memento + member to textclip
//#define kCurrentVersion 0x00010026
// added fIsSimpleMerge to MergeCommand
//#define kCurrentVersion 0x00010025
// added fTextClipsArray to TArmeMasterMovieChunk
//#define kCurrentVersion 0x00010024
// moved fStartTrim and fEndTrim in TVideoObject
//#define kCurrentVersion 0x00010023
// added fTransitionType to TVideoXFadeEffect
//#define kCurrentVersion 0x00010022
// #define kCurrentVersion 0x00010021
// added TArmeMasterMovieTextTrack in TArmeMasterMovie
//#define kCurrentVersion 0x00010020
// added fDataFileRefArray in TArmeDoc
//#define kCurrentVersion 0x00010019
// modified TArmeMasterMovieOriginalTrack (added fIndexArray)
//#define kCurrentVersion 0x00010018
// modified TArmeMasterMovieOriginalTrack
//#define kCurrentVersion 0x00010017
// modified MISplitLowLevelCommand
//#define kCurrentVersion 0x00010016
// added fIsRenderCommand in MIFreezeCommand
//#define kCurrentVersion 0x00010015
// NEW VIDEO ENGINE, NO backward compatibility
// added fOriginalTrack in MasterMovie
// removed fThumbTrack from TVideoClip
//#define kCurrentVersion 0x00010014
// added fDoc in the serialization of ArmeDataFileRef
// added fSourceAtomArray if TVideoEffect
// changed MICommand (fObjectArray instead of selection)
//#define kCurrentVersion 0x00010013
// added viewer top left position in documentModel
//#define kCurrentVersion 0x00010012
// added Scroll H and V in documentModel
//#define kCurrentVersion 0x00010011
// added ZoomIndex in documentModel
//#define kCurrentVersion 0x00010010
// added extra resize command in time stretch tracker (MIVideoTimeStretchTracker) as well as in audio processing command
//#define kCurrentVersion 0x0001000F
// added a background track to the master movie
//#define kCurrentVersion 0x0001000E
// added archiving of TArmeDoc::fPluginClassInstanceIndices
// #define kCurrentVersion 0x0001000D
//added fDurationInFile in ArmeChunk
//added fPreviewCodecType in TArmeMasterMovie
//added fSourceFile in ArmeDataFileRef
// add enlarge to creation commands
//#define kCurrentVersion 0x0001000C
//Added fPreviewCodec and fRenderCodec in MIDocumentModel

// #define kMinimalVersion 0x0001000B
//#define kCurrentVersion 0x0001000B
// changed MICreateWSObjsFromFiles

//#define kCurrentVersion 0x0001000A
// added fObjArray in MIMoveCommand
//#define kCurrentVersion 0x00010009
//added fViewerSize in MIDocumentModel
//#define kCurrentVersion 0x00010008

//added fArmeDataFileRef in TArmeTextClip
//#define kCurrentVersion 0x00010007
//added fWorkingCodecType to TArmeMasterMovie
//#define kCurrentVersion 0x00010006
//added fObjectHasBeenCompletelyDeleted to MIDeleteLowLevelCommand
//#define kCurrentVersion 0x00010005
//added FPS and BPM stuff in MIDocumentModel
//#define kCurrentVersion 0x00010004
//added the fOriginalTrack to the TVideoClipMemento (for Trim)
//#define kCurrentVersion 0x00010003
//added the fOriginalTrack to the TVideoClip (for Trim)
//#define kCurrentVersion 0x00010002
//added the library to the MIDocumentModel
//#define kCurrentVersion 0x00010001
//added fStartTrim and fEndTrim members to TVideoClip
//#define kCurrentVersion 0x00010000
//#define kMinimalVersion 0x0001000B

#ifndef MontageArchiveHandler_h
#include "MontageArchiveHandler.h"
#endif //MontageArchiveHandler_h

#ifndef MontageArchive_h
#include "MontageArchive.h"
#endif //MontageArchive_h

#import "MIObject.h"
#import "MIObjectPositionCombo.h"
#import "MIAudioProcessingCommand.h"
#import "MIAllCommands.h"
#import "MIDeleteLowLevelCommand.h"
#import "MIInsertLowLevelCommand.h"
#import "MIPasteLowLevelCommand.h"
#import "MISingleMoveCommand.h"
#import "MICreateWSObjFromFileCommand.h"
#import "MIMontageDocument.h"
#import "MIDocumentModel.h"
#import "MIObject.h"
#import "MIOverviewController.h"
#import "MIFreezeCommand.h"
#import "MIUnfreezeCommand.h"
#import "MICreateDeleteMarkerCommand.h"
#import "MIMoveMarkerCommand.h"
#import "MILibraryElement.h"
#import "MICreateAudioClipsFromRecordedTakesCommand.h"
#import "MIDeleteContainerCommand.h"
#import "MICreateWSObjsFromFileCommand.h"
#import "MIAdvancedFadeInCommand.h"
#import "MIAdvancedFadeOutCommand.h"

#include <typeinfo>

//#import "ArchiveTest.h"

UInt32 MontageArchiveHandler::GetOurSig() const
{
	return 'MTAR';
}

UInt32 MontageArchiveHandler::GetMaxVer() const
{
	return kCurrentVersion;
}

UInt32 MontageArchiveHandler::GetMinVer() const
{
	return kMinimalVersion;
}

UInt32 MontageArchiveHandler::GetCPPClassID(ArmeArchivable* obj)
{
	verntl(archivingEngine,5,"MontageArchiveHandler::GetCPPClassID");
	UInt32 baseType = ArmeArchiveHandler::GetCPPClassID(obj);
	vverntl(archivingEngine,5,baseType);
	
	const char* className = GetCPPObjectClassName(obj);
	vverntl(archivingEngine,5,className);

	UInt32 type = 0;
#define ARCH_CLASS(a) if(strcmp(#a,className) == 0) type = kArchClass_##a;
#include "MontageArchiveCPPClasses.h"
#undef ARCH_CLASS
	vverntl(archivingEngine,5,type);
	if(baseType == 0 && type == 0 )
	{
		verntl(archivingEngine,1,
			"MontageArchiveHandler::GetCPPClassID() for class " << className << " :  couldn't find type");
		char msg[256];
		sprintf(msg,"Couldn't find type for %s",className);
		ZzAssertMsg(0,msg);
	}
	if(baseType != 0 && type != 0 )
	{
		verntl(archivingEngine,1,
			"MontageArchiveHandler::GetCPPClassID() : class types declared in client and library " << className);
		ZzAssert(0);
	}
	if(type == 0)
		type = baseType;
	return type;
}

UInt32 MontageArchiveHandler::GetObjCClassID(void* obj)
{
	verntl(archivingEngine,5,"MontageArchiveHandler::GetObjCClassID");
	UInt32 baseType = ArmeArchiveHandler::GetObjCClassID(obj);
	vverntl(archivingEngine,5,baseType);
	const char* className = GetObjCObjectClassName((id)obj);
	vverntl(archivingEngine,5,className);
	UInt32 _type = 0;
#define ARCH_CLASS(a) if(strcmp(#a,className) == 0) _type = kArchClass_##a;
#include "MontageArchiveObjCClasses.h"
#undef ARCH_CLASS
	vverntl(archivingEngine,5,_type);
	if(baseType == 0 && _type == 0 )
	{
		verntl(archivingEngine,1,
			"MontageArchiveHandler::GetObjCClassID() for class " << className << " :  couldn't find type");
		ZzAssert(0);
	}
	if(baseType != 0 && _type != 0 )
	{
		verntl(archivingEngine,1,
			"MontageArchiveHandler::GetObjCClassID() : class types declared in client and library " << className);
		ZzAssert(0);
	}
	if(_type == 0)
		_type = baseType;
	return _type;
}

// debug stuff
const char* MontageArchiveHandler::GetNameFromClassID(UInt32 classID)
{
	if(classID == 0) return "NULL type";
#define ARCH_CLASS(a) else if(classID == kArchClass_##a) return #a;
#include "ArmeArchiveObjCClasses.h"
#include "ArmeArchiveCPPClasses.h"
#include "MontageArchiveObjCClasses.h"
#include "MontageArchiveCPPClasses.h"
#undef ARCH_CLASS
	else
		return "UNKNOWN classID";
}

id MontageArchiveHandler::CreateObjCObject(UInt32 classID)
{
	const char* className = GetNameFromClassID(classID);
	verntl(archivingEngine,5,"MontageArchiveHandler::CreateObjCObject( " << classID << " (" 
		<< className << ") )");
	id baseObj = ArmeArchiveHandler::CreateObjCObject(classID);
	id obj = nil;
	switch(classID)
	{
#ifdef ARCH_CLASS
#error ("ARCH_CLASS already defined")
#endif //ARCH_CLASS
#define ARCH_CLASS(a) \
		case kArchClass_##a : \
			obj = [[[a alloc] initFromArchive:this] autorelease]; \
			break;
#include "MontageArchiveObjCClasses.h"
#undef ARCH_CLASS
	}
	if(baseObj == nil && obj == nil)
	{
		verntl(archivingEngine,1,"baseObj == nil && obj == nil");
		ZzAssert(0); // check that the initFromArchive returns 'self' and that the class is in the enumeration.
	}
	if(baseObj != nil && obj != nil)
	{
		verntl(archivingEngine,1,"baseObj != nil && obj != nil");
		ZzAssert(0);
	}
	if(obj == nil)
		obj = baseObj;
		
	return obj;
}


ArmeArchivable* MontageArchiveHandler::CreateCPPObject(UInt32 classID)
{
	const char* className = GetNameFromClassID(classID);
	verntl(archivingEngine,5,"MontageArchiveHandler::CreateCPPObject( " << classID << " (" 
		<<  className << ") )");

	ArmeArchivable* baseObj = ArmeArchiveHandler::CreateCPPObject(classID);
	ArmeArchivable* obj = NULL;
	switch(classID)
	{
#ifdef ARCH_CLASS
#error ("ARCH_CLASS already defined")
#endif //ARCH_CLASS
#define ARCH_CLASS(a) \
		case kArchClass_##a : \
			obj = new a(this); \
			break;
#include "MontageArchiveCPPClasses.h"
#undef ARCH_CLASS
	}
	if(baseObj == NULL && obj == NULL)
	{
		verntl(archivingEngine,1,"baseObj == nil && obj == nil");
		ZzAssert(0);
	}
	if(baseObj != NULL && obj != NULL)
	{
		verntl(archivingEngine,1,"baseObj != nil && obj != nil");
		ZzAssert(0);
	}
	if(obj == NULL)
		obj = baseObj;
		
	return obj;
}


