/****************************************************************************
 *   Copyright (C) 2004 by Arboretum Systems, Inc.                          *
 *   Technical administrator: Alain Mazy, hav@mazy.be                       *
 *   Lead program designer: Georges Jaroslaw, gjaro@arboretum.com           *
 *                                                                          *
 *   HyperEngine-AV is a video, audio and text editor that can be used to   *
 *   record, import, edit, process and arrange together video, sound and    *
 *   text. These are all achieved in the program's free-form document       *
 *   window, with no limitations to the number of tracks.                   *
 *   The purpose of this program is to provide to users at all levels of    *
 *   expertise a readily accessible tool enabling them to create movies,    *
 *   slide shows or presentations.                                          *
 *                                                                          *
 *   HyperEngine-AV itself is free software. However, plug-ins that can be  *
 *   used as add-ons to HyperEngine-AV may or may not be free software, at  *
 *   the discretion of each plug-in developer and as specified by these     *
 *   plug-ins' respective licenses.                                         *
 *   You can redistribute HyperEngine-AV itself and/or modify it under the  *
 *   terms of the GNU General Public License as published by the Free       *
 *   Software Foundation; either version 2 of the License, or (at your      *
 *   option) any later version.                                             *
 *                                                                          *
 *   HyperEngine-AV is distributed in the hope that it will be useful, but  *
 *   WITHOUT ANY WARRANTY; without even the implied warranty of             *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the          *
 *   GNU General Public License for all applicable details.                 *
 *                                                                          *
 *   You should have received a copy of the GNU General Public License      *
 *   along with this program; if not, write to:                             *
 *   Free Software Foundation, Inc.,                                        *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.              *
 ****************************************************************************/
#import "MIMacroCommand.h"

@class MIWSSelection;
@class MIMainViewController;
@class MIObject;
class ArmeArchiveHandler;

enum {
	kFadeInFromBlack,
	kFadeOutToBlack,
};


@interface MIFadeInCommand : MIMacroCommand
{
	

}

-(id)initFromArchive:(ArmeArchiveHandler*)handler;
-(BOOL)writeToArchive:(ArmeArchiveHandler*)handler;
- (NSString*)commandName;
+ (BOOL)supportsSelection:(MIWSSelection*)sel;
- (id)initWithSelection:(MIWSSelection*)sel;
@end

@interface MIFadeVideoCommand : MIMacroCommand
{
	MIObject*		fObject;
	ArmeTime		fFrom;
	ArmeTime		fTo;
	SInt32			fType;
	BOOL			fCompleteObject;
}
- (id)initWithObjectToFade:(MIObject*)obj from:(ArmeTime)from to:(ArmeTime)to fadeType:(SInt32)type;
-(id)initFromArchive:(ArmeArchiveHandler*)handler;
-(BOOL)writeToArchive:(ArmeArchiveHandler*)handler;
- (NSString*)commandName;
- (MICmdStatus)doIt;
- (void)undoIt;
- (void)redoIt;
- (int)getNbLengthyTasks;
@end

@interface MIFadeVideoLowLevelCommand : MICommand
{
	SInt32 		fType;
	MIObject*	fObject;
}

- (id)initWithObjectToEncloseInFadeEffect:(MIObject*)obj fadeType:(SInt32)type;
-(id)initFromArchive:(ArmeArchiveHandler*)handler;
-(BOOL)writeToArchive:(ArmeArchiveHandler*)handler;
- (NSString*)commandName;
- (MICmdStatus)doIt;
- (BOOL)displaySetupDialog;
- (void)undoIt;
- (void)redoIt;
@end