/****************************************************************************
 *   Copyright (C) 2004 by Arboretum Systems, Inc.                          *
 *   Technical administrator: Alain Mazy, hav@mazy.be                       *
 *   Lead program designer: Georges Jaroslaw, gjaro@arboretum.com           *
 *                                                                          *
 *   HyperEngine-AV is a video, audio and text editor that can be used to   *
 *   record, import, edit, process and arrange together video, sound and    *
 *   text. These are all achieved in the program's free-form document       *
 *   window, with no limitations to the number of tracks.                   *
 *   The purpose of this program is to provide to users at all levels of    *
 *   expertise a readily accessible tool enabling them to create movies,    *
 *   slide shows or presentations.                                          *
 *                                                                          *
 *   HyperEngine-AV itself is free software. However, plug-ins that can be  *
 *   used as add-ons to HyperEngine-AV may or may not be free software, at  *
 *   the discretion of each plug-in developer and as specified by these     *
 *   plug-ins' respective licenses.                                         *
 *   You can redistribute HyperEngine-AV itself and/or modify it under the  *
 *   terms of the GNU General Public License as published by the Free       *
 *   Software Foundation; either version 2 of the License, or (at your      *
 *   option) any later version.                                             *
 *                                                                          *
 *   HyperEngine-AV is distributed in the hope that it will be useful, but  *
 *   WITHOUT ANY WARRANTY; without even the implied warranty of             *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the          *
 *   GNU General Public License for all applicable details.                 *
 *                                                                          *
 *   You should have received a copy of the GNU General Public License      *
 *   along with this program; if not, write to:                             *
 *   Free Software Foundation, Inc.,                                        *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.              *
 ****************************************************************************/

#define ZzAudioUtilities_h

#ifndef ZzAudioUtilities_h
#include "ZzAudioUtilities.h"
#endif //ZzAudioUtilities_h

#include <CoreAudio/CoreAudio.h>

void ZzAudioFillWithStereoFloatSin128(float* buffer, SInt32 nbFrames, SInt32 phase);
void ZzAudioFillWithStereoSInt16Sin128(SInt16* buffer, SInt32 nbFrames, SInt32 phase);
float* ZzAudioGetRingBufferAddress(float* RB, SInt32 RBNbBits, SInt32 nbChannels, SInt64 posInRB);
#ifdef __APPLE__

SInt32 ZzAudioCAGetNbAvailableOutputStreamsInDevice(AudioDeviceID inDeviceID);
SInt32 ZzAudioCAGetNbAvailableInputStreamsInDevice(AudioDeviceID inDeviceID);
#endif //#ifdef __APPLE__


/*! 
	@function ZzAudioMixStereoWithStrides
	
	this function mixes from a source stereo buffer to dest stereo buffer
	the data should be two contiguous channels of interleaved buffers
	
*/

void ZzAudioMixStereoWithStrides(
	float* 			dst, 
	SInt32 			dstLeftChannelIndex,
	SInt32			dstNbChannels,
	const float*	src, 
	SInt32 			srcLeftChannelIndex, 
	SInt32			srcNbChannels,
	SInt32 			nbFrames );

//ZzAudioMixStereoWithStridesDezip(float* raoTmpDst,(GetMaxStereoRAOCount() << 1),
